﻿#pragma once
#include "viplexcore_global.h"
#include <iostream>
#include <string>
#include <memory>
#include <map>
#include "viplexcommon/jsonserializer/jsonserializer.h"
#include "viplexcommon/jsonserializer/protocoljson.h"
#include "viplexcommon/interface/viplexerror.h"
#include "login/serchterminal.h"
#include "login/login.h"
#include "viplexcommon/interface/idatamanager.h"
#include "viplexcommon/http/httpHelper.h"
#include "viplexcommon/viplexcommon.h"
#include "verifytime/verifytime.h"
#include "viplexcorecommon/viplexrequester.h"
#include "viplexcommon/datamanager/datamanager.h"
#include "advancedfeatures/advancedfeatures.h"
#include "screenmanager/screenmanager.h"
#include "icareconfigurator/icareconfigurator.h"
#include "updatehelper/updatehelper.h"
#include "lightcontroller/lightcontroller.h"
#include "switchcontroller/switchcontroller.h"
#include "viplexcommon/ftp/ftpclient.h"
#include "statuscollector/statuscollector.h"
#include "videosourcecontroller/videosourcecontroller.h"
#include "screenmanager/screenmanager.h"
#include "appmanager/appmanager.h"
#include "networkconfigurator/networkconfigurator.h"
#include "programeditor/programeditor.h"
#include "usermanager/usermanager.h"
#include "databaseMigration/databaseMigration.h"
#include "feedback/feedback.h"
#include "cloudConfigurator/cloudConfigurator.h"
#include "monitorconfigurator/monitorconfigurator.h"
#include "screenconfiguration/screenconfiguration.h"

#include "temperaturecontroller/temperaturecontroller.h"
#include "volumecontroller/volumecontroller.h"
#include "ledsplicer/ledsplicer.h"
#include "listmanager/listmanager.h"
#include "nodeserverlist/nodeserverlist.h"
#include "timezonelist/timezonelist.h"
#include "viplexcoreassist/viplexcoreassist.h"
#include "powermanager/powermanager.h"
#include "vpnconnection/vpnconnection.h"
#include "playlogger/playlogger.h"
#include "playfont/playfont.h"
#include "runninglogger/runninglogger.h"
#include "viplexcore/radiofrequency/radiofrequency.h"
#include "filemanager/filemanager.h"
#include "acquisitionreceiver/acquisitionreceiver.h"
#include "usbvplay/usbvplay.h"
#include "ipaudio/ipaudio.h"
#include "sensor/sensor.h"
#include "externaldelivery/externaldelivery.h"
#include "powercontroller/powercontroller.h"
#include "batchsetapi/batchsetapi.h"
#include "logupload/logupload.h"
#include "burypoint.h"
class QApplication;
class VIPLEX_EXPORT ViplexCore
{
public:
    static ViplexCore &getInstance()
    {
        static ViplexCore instance;
        return instance;
    }

    static std::shared_ptr<SerchTerminal> getSearchTerminal()
    {
        return getInstance().m_searchTerminal;
    }
    static std::shared_ptr<Login> getLogin()
    {
        return getInstance().m_login;
    }
    static std::shared_ptr<VerfityTime> getVerfityTime()
    {
        return getInstance().m_verfityTime;
    }
    static std::shared_ptr<ICareConfigurator> getRemotemanager()
    {
        return getInstance().m_icareconfigurator;
    }
    static std::shared_ptr<ScreenManager> getScreenManager()
    {
        return getInstance().m_screenManager;
    }
	static std::shared_ptr<AdvancedFeatures> getAdvancedFeature()
	{
		return getInstance().m_advancedfeature;
	}
    static std::shared_ptr<LightController> getLightController()
    {
        return getInstance().m_lightController;
    }
    static std::shared_ptr<SwitchController> getSwitchController()
    {
        return getInstance().m_switchController;
    }
	static std::shared_ptr<VideoSourceController> getScreenCtrlVideo()
	{
		return getInstance().m_screenVideo;
	}
	static std::shared_ptr<StatusCollector> getStatusCollector()
	{
		return getInstance().m_statusCollector;
	}
    static std::shared_ptr<NetworkConfigurator> getNetworkConfigurator()
    {
        return getInstance().m_networkConfigurator;
    }
	static std::shared_ptr<AppManager> getAppManage()
	{
		return getInstance().m_appManager;
	}
	static std::shared_ptr<ListManager> getListManager()
	{
		return getInstance().m_listmanager;
	}
    static std::shared_ptr<UpdateHelper> getUpdateHelper()
    {
        return getInstance().m_updateHelper;

    }
	static std::shared_ptr<ProgramEditor> getEditProgram()
	{
		return getInstance().m_editProgram;

	}
    static std::shared_ptr<UserManager> getUserManager()
    {
        return getInstance().m_userManager;
    }
	static std::shared_ptr<DatabaseMigration> getDatabaseMigration()
	{
		return getInstance().m_databaseMigration;
	}
    static std::shared_ptr<Feedback> getFeedbackInfo()
    {
        return getInstance().m_feedback;
    }
    static std::shared_ptr<TemperatureController> getTemperatureController() 
    {
        return getInstance().m_temperatureController;
    }
    static std::shared_ptr<VolumeController> getVolumeController() 
    {
        return getInstance().m_volumeController;
    }


	static std::shared_ptr<CloudConfigurator> getCloudConfigurator()
	{
		return getInstance().m_cloudconfigurator;
	}
	static std::shared_ptr<MonitorConfigurator> getMonitorConfigurator()
	{
		return getInstance().m_monitorconfigurator;
	}
	static std::shared_ptr<ScreenConfiguration> getScreenConfiguration()
	{
		return getInstance().m_screenconfiguration;
	}
	static std::shared_ptr<LEDSplicer> getLEDSplicer()
	{
		return getInstance().m_ledsplicer;
	}
	static std::shared_ptr<NodeServerList> getNodeServerList()
	{
		return getInstance().m_nodeserverlist;
	}
	static std::shared_ptr<TimeZoneList> getTimeZoneList()
	{
		return getInstance().m_timeZoneList;
	}
	static std::shared_ptr<ViplexCoreAssist> getViplexCoreAssist()
	{
		return getInstance().m_viplexCoreAssist;
	}
    static std::shared_ptr<PowerManager> getPowerManager() 
    {
        return getInstance().m_powerManager;
    }
    static std::shared_ptr<VPNConnection> getVPNConnection() 
    {
        return getInstance().m_vpnConnection;
    }
    static std::shared_ptr<PlayLogger> getPlayLogger() 
    {
        return getInstance().m_PlayLogger;
    }
    static std::shared_ptr<PlayFont> getPlayFont() 
    {
        return getInstance().m_playFont;
    }
	static std::shared_ptr<RunningLogger> getRunningLogger()
	{
		return getInstance().m_RunningLogger;
	}
	static std::shared_ptr<FileManager> getFilemanager()
	{
		return getInstance().m_fileManager;
	}
    static std::shared_ptr<AcquisitionReceiver> getAcquisitionReceiver() 
    {
        return getInstance().m_AcquisitionReceiver;
    }
	static std::shared_ptr<RadioFrequency> getRadioFrequency()
	{
		return getInstance().m_RadioFrequency;
	}
	static std::shared_ptr<USBVplay> getUSBVplay()
	{
		return getInstance().m_usbVplay;
	}
    static std::shared_ptr<IPAudio> getIPAudio()
    {
        return getInstance().m_IpAudio;
    }
    static std::shared_ptr<Sensor> getSensor() 
    {
        return getInstance().m_Sensor;
    }
	static std::shared_ptr<ExternalDelivery> getExternalDelivery()
	{
		return getInstance().m_ExternalDelivery;
	}
	static std::shared_ptr<PowerController> getPowerController()
	{
		return getInstance().m_powerController;
	}
	static std::shared_ptr<BatchSetAPI> getBatchSetAPI()
	{
		return getInstance().m_batchSetAPI;
	}
	static std::shared_ptr<LogsDownloadAndUpload> getLogUpload()
	{
		return getInstance().m_logUpload;
	}


    /*
    * @breaf 只限于ios,ios需要在二次init时干掉socket和重新创建socket 该接口在init之前调用
    */
    void setPlatform(const std::string &platform);
    
    ViplexError init(const std::string &sdkRootDir, const std::string &credentials,const EnumType type = enNova);
    ViplexError initCore(const std::string &sdkRootDir, const EnumType type = enNova);
private:

    ViplexCore();
    void initViplexcore();

    std::unique_ptr<ViplexCommon> m_pViplexCommon;
	std::unique_ptr<HttpHelper> m_pHttphelper;
	std::unique_ptr<FtpClient> m_pFtphelper;
    ViplexRequester m_requester;
    DataManager m_dataManager;
    HttpHelper m_httphelper;
	FtpClient m_ftp;
    std::string m_platform="";
    std::shared_ptr<QApplication> m_app;
    BuryPoint buryPoint;
    //各模块
    std::shared_ptr<SerchTerminal> m_searchTerminal;
    std::shared_ptr<Login> m_login;
    std::shared_ptr<VerfityTime> m_verfityTime;
    std::shared_ptr<ICareConfigurator> m_icareconfigurator;
    std::shared_ptr<ScreenManager> m_screenManager;
	std::shared_ptr<AdvancedFeatures> m_advancedfeature;
    std::shared_ptr<LightController> m_lightController;
    std::shared_ptr<SwitchController> m_switchController;

    std::shared_ptr<VideoSourceController> m_screenVideo;
    std::shared_ptr<StatusCollector> m_statusCollector;
    std::shared_ptr<NetworkConfigurator> m_networkConfigurator;
    std::shared_ptr<AppManager> m_appManager;
    std::shared_ptr<ListManager> m_listmanager;
    std::shared_ptr<UpdateHelper> m_updateHelper;
	std::shared_ptr<ProgramEditor> m_editProgram;
    std::shared_ptr<UserManager> m_userManager;
	std::shared_ptr<DatabaseMigration> m_databaseMigration;
    std::shared_ptr<Feedback> m_feedback;
    std::shared_ptr<TemperatureController> m_temperatureController;
    std::shared_ptr<VolumeController> m_volumeController;


	std::shared_ptr<CloudConfigurator> m_cloudconfigurator;
	std::shared_ptr<MonitorConfigurator> m_monitorconfigurator;
	std::shared_ptr<ScreenConfiguration> m_screenconfiguration;
	std::shared_ptr<LEDSplicer> m_ledsplicer;
	std::shared_ptr<NodeServerList> m_nodeserverlist;
	std::shared_ptr<TimeZoneList> m_timeZoneList;
	std::shared_ptr<ViplexCoreAssist> m_viplexCoreAssist;
	//std::shared_ptr<UpdateHelper> getNewUpdateHelper();
	//std::shared_ptr<EditProgram> getNewEditProgram();
    std::shared_ptr<PowerManager> m_powerManager;
    std::shared_ptr<VPNConnection> m_vpnConnection;
    std::shared_ptr<PlayLogger> m_PlayLogger;
    std::shared_ptr<PlayFont> m_playFont;
	std::shared_ptr<RunningLogger> m_RunningLogger;
	std::shared_ptr<FileManager> m_fileManager;
    std::shared_ptr<AcquisitionReceiver> m_AcquisitionReceiver;
	std::shared_ptr<RadioFrequency> m_RadioFrequency;
	std::shared_ptr<USBVplay> m_usbVplay;
    std::shared_ptr<IPAudio> m_IpAudio;
    std::shared_ptr<Sensor> m_Sensor;
    std::shared_ptr<ExternalDelivery> m_ExternalDelivery;
	std::shared_ptr<PowerController> m_powerController;
	std::shared_ptr<BatchSetAPI> m_batchSetAPI;

	std::shared_ptr<LogsDownloadAndUpload> m_logUpload;
};
